<?php
/**
 * @file
 * Admin forms for warden
 */

/**
 * Page callback: System settings settings.
 *
 * @see warden_menu()
 */
function warden_form(&$form_state) {

  $form['warden_server_host_path'] = array(
    '#type' => 'textfield',
    '#title' => t('Warden Dashboard URL'),
    '#description' => t('URL of the Warden Dashboard. This is where this this will be registered with for monitoring.'),
    '#default_value' => variable_get('warden_server_host_path', ''),
  );

  if (variable_get('warden_server_host_path', '') == '') {
    return system_settings_form($form);
  }

  $form['warden_public_allow_public'] = array(
    '#type' => 'checkbox',
    '#title' => t('Allow public calls'),
    '#description' => t('Allow calls from ip-adresses as defined below. Please note that they should be comma separated.'),
    '#default_value' => variable_get('warden_public_allow_public', '0'),
  );

  $form['warden_public_allow_ips'] = array(
    '#type' => 'textfield',
    '#title' => t('Comma seperated list of allowed IP addresses'),
    '#default_value' => variable_get('warden_public_allow_ips', '127.0.0.1,::1'),
  );

  $form['add_site'] = array(
    '#type' => 'submit',
    '#value' => t('Add this site to your Warden Dashboard'),
    '#submit' => array('warden_add_site'),
  );

  //return system_settings_form($form);
  $form = system_settings_form($form);

  // Get rid of the "Reset to defaults" button, cos we don't like it.
  unset($form['buttons']['reset']);

  return $form;
}

/**
 * @param $form
 * @param $form_state
 * @throws Exception
 */
function warden_add_site($form, &$form_state) {
  global $base_url;
  $site_url = $base_url;
  $site_url .= "|" . variable_get('warden_token', 'Error-no-token');
  $site_url_encrypted = warden_get_encryption()->encrypt($site_url);
  $site_host_path = variable_get('warden_server_host_path', '');
  $url = $site_host_path . '/sites/add?data=' . $site_url_encrypted;

  if (module_exists('overlay') && overlay_get_mode() == 'child') {
    unset($_GET['destination']);
    overlay_close_dialog($url, array('external' => TRUE));
    $form_state['redirect'] = FALSE;
  }
  else {
    $form_state['redirect'] = $url;
  }
}
